"""
Autogenerated module using `pop-create-idem <https://gitlab.com/saltstack/pop/pop-create-idem>`__
"""


async def sddc_id(hub, ctx, org: str, id: str) -> None:
    """
    **Autogenerated function**
    
    Move Sddc to new support window

    Args:
        org(str): Organization identifier.
        id(str): Target Support Window ID.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.tbrs.sddc_id(ctx, org=value, id=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.tbrs.sddc_id org=value, id=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="put",
        path=ctx.acct.endpoint_url + "/orgs/{org}/tbrs/support-window/{id}".format(**{"org": org, "id": id}),
        query_params={},
        data={}
    )


async def sddc_state(hub, ctx, org: str) -> None:
    """
    **Autogenerated function**
    
    Retreive all reservations for all SDDCs in this org

    Args:
        org(str): Organization identifier.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.tbrs.sddc_state(ctx, org=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.tbrs.sddc_state org=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="post",
        path=ctx.acct.endpoint_url + "/orgs/{org}/tbrs/reservation".format(**{"org": org}),
        query_params={},
        data={}
    )


async def tbrs(hub, ctx, org: str, minimum_seats_available: int = None, created_by: str = None) -> None:
    """
    **Autogenerated function**
    
    Get all available support windows

    Args:
        org(str): Organization identifier.
        minimum_seats_available(int, optional): minimum seats available (used as a filter). Defaults to None.
        created_by(str, optional): user name which was used to create the support window (used as a filter). Defaults to None.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.tbrs.tbrs(ctx, org=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.tbrs.tbrs org=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="get",
        path=ctx.acct.endpoint_url + "/orgs/{org}/tbrs/support-window".format(**{"org": org}),
        query_params={"minimumSeatsAvailable": minimum_seats_available, "createdBy": created_by},
        data={}
    )

